/**
 * Generates the next color in the sequence, going from 0,0,0 to 255,255,255.
 * via http://stackoverflow.com/a/15804183
 *
 * @param dataIndex
 * @returns {string}
 */
const genColorByIndex = dataIndex => {
  let ret = [];
  if (dataIndex < 16777215) {
    ret.push(dataIndex & 0xff); // R
    ret.push((dataIndex & 0xff00) >> 8); // G
    ret.push((dataIndex & 0xff0000) >> 16); // B
  }
  return 'rgb(' + ret.join(',') + ')';
};

export default genColorByIndex;
